AC_DEFUN([AC_CHECK_CURL], [
  AC_ARG_VAR([CURL_CONFIG], [Path to curl-config utility])
  AC_ARG_VAR([LIBCURL_CFLAGS], [C compiler flags for CURL, overriding curl-config])
  AC_ARG_VAR([LIBCURL_LIBS], [linker flags for CURL, overriding curl-config])

  if test "x$LIBCURL_CFLAGS" = "x" && test "x$LIBCURL_LIBS" = "x"; then
      if test "x$CURL_CONFIG" = "x"; then
          AC_PATH_PROG([CURL_CONFIG], [curl-config], [no])
      else
          AC_MSG_CHECKING([for curl-config])
          AC_MSG_RESULT([$CURL_CONFIG])
      fi
      if test "$CURL_CONFIG" = "no"; then
          AC_MSG_ERROR([
  *** The curl-config script could not be found. Please install the development
  *** headers and libraries for CURL or set PATH to the directory that
  *** contains curl-config.
          ])
      fi
      LIBCURL_CFLAGS=`$CURL_CONFIG --cflags`
      LIBCURL_LIBS=`$CURL_CONFIG --libs`
      AC_DEFINE(HAVE_LIBCURL,1,
        [Define to 1 if you have a functional curl library.])
      AC_SUBST(LIBCURL_CFLAGS)
      AC_SUBST(LIBCURL_LIBS)
  else
      AC_MSG_NOTICE([not checking for CURL])
  fi
])
