//======================================================================
//  flpost; smtp-tls.h
//    Author: Dave Freese, W1HKJ <w1hkj@w1hkj.com>
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the
//
//  Free Software Foundation, Inc.
//  51 Franklin Street, Fifth Floor
//  Boston, MA  02110-1301 USA.
//
// ---------------------------------------------------------------------

#ifndef SMTP_TLS_H
#define SMTP_TLS_H

#include <stdio.h>
#include <string.h>
#include <string>

#include <curl/curl.h>

#define FROM    "nbems.test@gmail.com" //"<nbems.test@gmail.com>"
#define TO      "w1hkj@bellsouth.net"  //"<w1hkj@bellsouth.net>"
#define CC      "ad5xj@qso.com"        // "feedback@w1hkj.com"  "<ad5xj@qso.com>"
#define SUBJ    "flpost test message"
#define BODY    "Message router for flmsg, flamp and mail."

#define USERNAME "nbems.test@gmail.com"
#define PASSWORD "w1hkj1938"
#define SMTP_SERVER "smtps://smtp.gmail.com"
#define SMTP_PORT "465"

class c_smtp_mail {

private:
	CURL *curl;
	CURLcode res;
	bool was_sent = false;
	struct curl_slist *recipients;
	std::string payload;
	std::string from_;
	std::string to_;
	std::string cc_;
	std::string subj_;
	std::string body_;
	std::string username_;
	std::string password_;
	std::string server_url_;
	std::string server_port_;

public:
	c_smtp_mail() {
		was_sent = false;
		curl = (CURL *)0;
		res = CURLE_OK;
		recipients = NULL;
		payload.clear();
		from_.clear();
		to_.clear();
		cc_.clear();
		subj_.clear();
		body_.clear();
		username_.clear();
		password_.clear();
		server_url_.clear();
		server_port_.clear();
	}
	~c_smtp_mail() {}

	int send_mail(void);

	const char *hexstr(int d);
	std::string dump_string(std::string d_in);

	static size_t payload_source(void *ptr, size_t size, size_t nmemb, void *userp);
	static int my_trace(
		CURL *handle,
		curl_infotype type,
		char *data,
		size_t size,
		void *userp
	);

	void from(std::string s) { from_ = s; }
	std::string from() { return from_; }
	void to(std::string s) { to_ = s; }
	std::string to() { return to_; }
	void cc(std::string s) { cc_ = s; }
	std::string cc() { return cc_; }
	void subj(std::string s) { subj_ = s; }
	std::string subj() { return subj_; }
	void body(std::string s) { body_ = s; }
	std::string body() { return body_; }
	void username(std::string s) { username_ = s; }
	std::string username() { return username_; }
	void password(std::string s) { password_ = s; }
	std::string password() { return password_; }
	void server_url(std::string s) { server_url_ = s; }
	std::string server_url() { return server_url_; }
	void server_port(std::string s) { server_port_ = s; }
	std::string server_port() { return server_port_; }

};

#endif // SMTP_TLS_H
