// ---------------------------------------------------------------------
//
// flpost; status.h
//
// Copyright (C) 2019
//              David Freese, W1HKJ
//
// flpost is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// flrig is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
// ---------------------------------------------------------------------


#include <iostream>
#include <fstream>
#include <string>

#include <FL/Fl_Preferences.H>

#include "status.h"
#include "config.h"
#include "main.h"
#include "flpost_ui.h"

status progStatus = {
	50,		// int mainX;
	50,		// int mainY;

	0,		// int	rpc_level;

	"",		// std::string mail_out_url;
	"",		// std::string mail_out_port;
	"",		// std::string mail_in_url;
	"",		// std::string mail_in_port;
	"",		// std::string mail_user_name;
	"",		// std::string mail_user_password;
	""		// std::string mail_from;
};

void status::saveLastState()
{
	Fl_Preferences flpost_pref(HomeDir.c_str(), "w1hkj.com",  PACKAGE_NAME);

	int mX = flpost_main_window->x();
	int mY = flpost_main_window->y();
	if (mX >= 0 && mX >= 0) {
		mainX = mX;
		mainY = mY;
	}

	flpost_pref.set("version", PACKAGE_VERSION);
	flpost_pref.set("mainx", mX);
	flpost_pref.set("mainy", mY);

	mail_in_port = mail_io.server_port();
	mail_in_url = mail_io.server_url();
	mail_out_port = mail_io.server_port();
	mail_out_url = mail_io.server_url();
	mail_user_name = mail_io.username();
	mail_user_password = mail_io.password();

	flpost_pref.set("mail_out_url", mail_out_url.c_str());
	flpost_pref.set("mail_out_port", mail_out_port.c_str());
	flpost_pref.set("mail_in_url", mail_in_url.c_str());
	flpost_pref.set("mail_in_port", mail_in_port.c_str());
	flpost_pref.set("mail_user_name", mail_user_name.c_str());
	flpost_pref.set("mail_user_password", mail_user_password.c_str());
	flpost_pref.set("mail_from", mail_from.c_str());

}

void status::loadLastState()
{
	Fl_Preferences flpost_pref(HomeDir.c_str(), "w1hkj.com", PACKAGE_NAME);

	if (flpost_pref.entryExists("version")) {
		char defbuffer[500];

		flpost_pref.get("mainx", mainX, mainX);
		flpost_pref.get("mainy", mainY, mainY);

		memset(defbuffer, 0, sizeof(defbuffer));
		flpost_pref.get("mail_out_url", defbuffer, "", 499);
		mail_out_url = defbuffer;

		memset(defbuffer, 0, sizeof(defbuffer));
		flpost_pref.get("mail_out_port", defbuffer, "", 499);
		mail_out_port = defbuffer;

		memset(defbuffer, 0, sizeof(defbuffer));
		flpost_pref.get("mail_in_url", defbuffer, "", 499);
		mail_in_url = defbuffer;

		memset(defbuffer, 0, sizeof(defbuffer));
		flpost_pref.get("mail_in_port", defbuffer, "", 499);
		mail_in_port = defbuffer;

		memset(defbuffer, 0, sizeof(defbuffer));
		flpost_pref.get("mail_user_name", defbuffer, "", 499);
		mail_user_name = defbuffer;

		memset(defbuffer, 0, sizeof(defbuffer));
		flpost_pref.get("mail_user_password", defbuffer, "", 499);
		mail_user_password = defbuffer;

		mail_io.server_url(mail_out_url);
		inp_mail_out_url->value(mail_out_url.c_str());

		mail_io.server_port(mail_out_port);
		inp_mail_out_port->value(mail_out_port.c_str());

		mail_io.username(mail_user_name);
		inp_mail_user_name->value(mail_user_name.c_str());

		mail_io.password(mail_user_password);
		inp_mail_user_password->value(mail_user_password.c_str());

		mail_io.from(mail_from);
		inp_from->value(mail_from.c_str());

	}
}

